
Core - Bug # 46679

Status: Closed Priority: Should have
Author: Martin Kästner Category: File Abstraction Layer (FAL)
Created: 2013-03-26 Assigned To:
Updated: 2014-11-03 Due date:
TYPO3 Version: 6.0
PHP Version:
Complexity: hard
Is Regression: No
Sprint Focus:
Subject: impexp: Import in v6 fails with fal-error
Description

I have tried an export in t3 gov v6.0.4 and a reimport in the same version. The import fails with an "Uncaught TYPO3 Exception" and
message "#1317178604: No file found for given UID.". I tried varios options (include relations and not include, exclude all files) but no
import were sucessful. In Version 4.7.x the file is imported.

Here the Exception:

Uncaught TYPO3 Exception
#1317178604: No file found for given UID. (More information)

InvalidArgumentException thrown in file
C:\wamp\www\gov604\typo3\sysext\core\Classes\Resource\ResourceFactory.php in line 262.

11 TYPO3\CMS\Core\Resource\ResourceFactory::getFileObject("0")

C:\wamp\www\gov604\typo3\sysext\core\Classes\DataHandling\DataHandler.php:

01803:      // @todo in future versions this needs to be modified to handle FAL objects natively
01804:      if (\TYPO3\CMS\Core\Utility\MathUtility::canBeInterpretedAsInteger($theFile)) {

01805:       $fileObject = \TYPO3\CMS\Core\Resource\ResourceFactory::getInstance()->getFileObject($theFile);

01806:       $theFile = $fileObject->getForLocalProcessing(FALSE);
01807:      }

10 TYPO3\CMS\Core\DataHandling\DataHandler::checkValue_group_select_file(array, array, NULL, NULL, "new", "tt_content",
"NEW515178722838c", "tt_content:NEW515178722838c:multimedia")

C:\wamp\www\gov604\typo3\sysext\core\Classes\DataHandling\DataHandler.php:

01628: 
01629:    case 'file':

01630:     $valueArray = $this->checkValue_group_select_file($valueArray, $tcaFieldConf, $curValue, $uploadedFiles, $status,
$table, $id, $recFID);

01631:     break;
01632:    case 'db':
9 TYPO3\CMS\Core\DataHandling\DataHandler::checkValue_group_select(array, "0", array, array, NULL, "multimedia")

C:\wamp\www\gov604\typo3\sysext\core\Classes\DataHandling\DataHandler.php:

01427: 
01428:   case 'select':

01429:    $res = $this->checkValue_group_select($res, $value, $tcaFieldConf, $PP, $uploadedFiles, $field);

01430:    break;
01431:   case 'inline':

8 TYPO3\CMS\Core\DataHandling\DataHandler::checkValue_SW(array, "0", array, "tt_content", "NEW515178722838c", NULL,
"new", 304, "tt_content:NEW515178722838c:multimedia", "multimedia", NULL, 304)

C:\wamp\www\gov604\typo3\sysext\core\Classes\DataHandling\DataHandler.php:

01374:   $tcaFieldConf = $GLOBALS['TCA'][$table]['columns'][$field]['config'];
01375:   // Preform processing:

01376:   $res = $this->checkValue_SW($res, $value, $tcaFieldConf, $table, $id, $curValue, $status, $realPid, $recFID, $field,
$this->uploadedFileArray[$table][$id][$field], $tscPID);

01377:   return $res;
01378:  }

7 TYPO3\CMS\Core\DataHandling\DataHandler::checkValue("tt_content", "multimedia", "0", "NEW515178722838c", "new", 304, 304)

C:\wamp\www\gov604\typo3\sysext\core\Classes\DataHandling\DataHandler.php:

01231:       if (isset($GLOBALS['TCA'][$table]['columns'][$field])) {
01232:        // Evaluating the value

01233:        $res = $this->checkValue($table, $field, $fieldValue, $id, $status, $realPid, $tscPID);

01234:        if (array_key_exists('value', $res)) {
01235:         $fieldArray[$field] = $res['value'];

6 TYPO3\CMS\Core\DataHandling\DataHandler::fillInFieldArray("tt_content", "NEW515178722838c", array, array, 304, "new", 304)

C:\wamp\www\gov604\typo3\sysext\core\Classes\DataHandling\DataHandler.php:

00979:        }
00980:        // Processing of all fields in incomingFieldArray and setting them in $fieldArray

00981:        $fieldArray = $this->fillInFieldArray($table, $id, $fieldArray, $incomingFieldArray, $theRealPid, $status, $tscPID);

00982:        // NOTICE! All manipulation beyond this point bypasses both "excludeFields" AND possible "MM" relations / file uploads to
field!
00983:        // Forcing some values unto field array:

5 TYPO3\CMS\Core\DataHandling\DataHandler::process_datamap()
C:\wamp\www\gov604\typo3\sysext\impexp\Classes\ImportExport.php:

01260:   $tce->reverseOrder = 1;
01261:   $tce->start($this->import_data, array());

01262:   $tce->process_datamap();

01263:   $this->callHook('after_writeRecordsRecords', array(
01264:    'tce' => &$tce

4 TYPO3\CMS\Impexp\ImportExport::writeRecords_records(274)

C:\wamp\www\gov604\typo3\sysext\impexp\Classes\ImportExport.php:

01115:   // Fields with "hard" relations to database, files and flexform fields are kept empty during this run
01116:   $this->writeRecords_pages($pid);

01117:   $this->writeRecords_records($pid);

01118:   // Finally all the file and DB record references must be fixed. This is done after all records have supposedly been written to
database:
01119:   // $this->import_mapId will indicate two things: 1) that a record WAS written to db and 2) that it has got a new id-number.

3 TYPO3\CMS\Impexp\ImportExport::importData(274)

C:\wamp\www\gov604\typo3\sysext\impexp\Classes\Controller\ImportExportController.php:

00860:      if ($inData['import_file']) {
00861:       if (!count($extKeysToInstall)) {

00862:        $import->importData($this->id);

00863:        \TYPO3\CMS\Backend\Utility\BackendUtility::setUpdateSignal('updatePageTree');
00864:       } else {

2 TYPO3\CMS\Impexp\Controller\ImportExportController::importData(array)

C:\wamp\www\gov604\typo3\sysext\impexp\Classes\Controller\ImportExportController.php:

00066:    }
00067:    // Call import interface:

00068:    $this->importData($inData);

00069:    break;
00070:   }

1 TYPO3\CMS\Impexp\Controller\ImportExportController::main()

C:\wamp\www\gov604\typo3\sysext\impexp\app\index.php:

00075: $SOBE = \TYPO3\CMS\Core\Utility\GeneralUtility::makeInstance('TYPO3\\CMS\\Impexp\\Controller\\ImportExportController');
00076: $SOBE->init();
00077: $SOBE->main();

00078: $SOBE->printContent();
00079: ?>

Related issues:
related to Core - Task # 52593: Impexp: make 4.x exports work as import in 6.x Resolved 2013-10-07
related to Core - Task # 55431: Impexp: file contents of sys_file are not inc... Resolved 2014-01-29
duplicated by Core - Task # 49227: Files missing in import/export Closed 2013-06-18

History
#1 - 2013-08-07 18:18 - Marc Bastian Heinrichs
- Category set to File Abstraction Layer (FAL)
- Status changed from New to Accepted
- Target version set to 6.2.0

#2 - 2013-08-07 20:40 - Gerrit Code Review
- Status changed from Accepted to Under Review

Patch set 1 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/22939

#3 - 2013-08-07 20:57 - Gerrit Code Review

Patch set 2 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/22939

#4 - 2013-08-07 21:00 - Marc Bastian Heinrichs

Martin, could you test the patch from https://review.typo3.org/#/c/22939/2/ if it works for your import?

You also need the patch from #49386.

#5 - 2013-10-07 18:27 - Marc Bastian Heinrichs
- Status changed from Under Review to Accepted
- Complexity set to hard
- Is Regression set to No

Created an own issue (#52593) for my patch, because it will fix the import of 4.x exports in version 6.x only.

#6 - 2013-11-02 17:03 - Sten _

hi Marc, your patch works only partially

importing failed...

error: #1321023156: uid property is already set. Cannot merge index record. (More information)
Trace is here: http://pastebin.com/z27m8qDR

#7 - 2014-01-07 14:10 - Ernesto Baschny
- Parent task set to #54542

#8 - 2014-01-17 18:44 - Marc Bastian Heinrichs
- Assigned To set to Marc Bastian Heinrichs

#9 - 2014-01-31 16:40 - Marc Bastian Heinrichs
- Parent task changed from #54542 to #55520

#10 - 2014-01-31 17:37 - Marc Bastian Heinrichs
- Status changed from Accepted to Needs Feedback
- Assigned To changed from Marc Bastian Heinrichs to Martin Kästner

Is your content based on the original 6.0.4 introduction package and you translated the content to german? Or is it updated from a older TYPO
Version.

Really wondering why tt_content field multimedia is integer 0 in your data.

#11 - 2014-03-19 11:12 - Ingo Schmitt
- Parent task deleted (#55520)

#12 - 2014-06-21 18:27 - Marc Bastian Heinrichs

Works for you now in 6.2?

#13 - 2014-11-03 15:18 - Alexander Opitz
- Status changed from Needs Feedback to Closed
- Assigned To deleted (Martin Kästner)
- Target version deleted (6.2.0)

No feedback within the last 90 days => closing this issue.

If you think that this is the wrong decision or experience this issue again, then please write to the mailing list typo3.teams.bugs with issue number and
an explanation or open a new ticket and add a relation to this ticket number.
